#version 460

layout(location = 0) in vec3 aPos;
layout(location = 1) in vec3 aColor;
layout(location = 2) in vec2 aTexCoords;

layout(location = 0) out vec4 vertColor;
layout(location = 1) out vec2 vertTexCoords;

layout(set = 1, binding = 0) uniform UBO {
    mat4 viewproj;
    mat4 model;
};

void main() {
    vertTexCoords = aTexCoords;
    vertColor = vec4(aColor, 1.0f);
    
    mat4 mvp = viewproj * model;
    gl_Position = mvp * vec4(aPos, 1.0f);
}
